/* ClipboardManager.c generated by valac 0.56.17, the Vala compiler
 * generated from ClipboardManager.vala, do not modify */

/*
* Copyright (c) 2017 David Hewitt (https://github.com/davidmhewitt)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: David Hewitt <davidmhewitt@gmail.com>
*/

#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdkx.h>
#include <X11/extensions/XTest.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define CLIPPED_TYPE_CLIPBOARD_MANAGER (clipped_clipboard_manager_get_type ())
#define CLIPPED_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManager))
#define CLIPPED_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManagerClass))
#define CLIPPED_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CLIPPED_TYPE_CLIPBOARD_MANAGER))
#define CLIPPED_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CLIPPED_TYPE_CLIPBOARD_MANAGER))
#define CLIPPED_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManagerClass))

typedef struct _ClippedClipboardManager ClippedClipboardManager;
typedef struct _ClippedClipboardManagerClass ClippedClipboardManagerClass;
typedef struct _ClippedClipboardManagerPrivate ClippedClipboardManagerPrivate;
enum  {
	CLIPPED_CLIPBOARD_MANAGER_0_PROPERTY,
	CLIPPED_CLIPBOARD_MANAGER_NUM_PROPERTIES
};
static GParamSpec* clipped_clipboard_manager_properties[CLIPPED_CLIPBOARD_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	CLIPPED_CLIPBOARD_MANAGER_ON_TEXT_COPIED_SIGNAL,
	CLIPPED_CLIPBOARD_MANAGER_NUM_SIGNALS
};
static guint clipped_clipboard_manager_signals[CLIPPED_CLIPBOARD_MANAGER_NUM_SIGNALS] = {0};

struct _ClippedClipboardManager {
	GObject parent_instance;
	ClippedClipboardManagerPrivate * priv;
};

struct _ClippedClipboardManagerClass {
	GObjectClass parent_class;
	void (*start) (ClippedClipboardManager* self);
};

struct _ClippedClipboardManagerPrivate {
	GtkClipboard* clipboard;
};

static gint ClippedClipboardManager_private_offset;
static gpointer clipped_clipboard_manager_parent_class = NULL;

VALA_EXTERN GType clipped_clipboard_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ClippedClipboardManager, g_object_unref)
VALA_EXTERN void clipped_clipboard_manager_start (ClippedClipboardManager* self);
static void clipped_clipboard_manager_on_clipboard_event (ClippedClipboardManager* self);
static void _clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                               GdkEventOwnerChange* event,
                                                                               gpointer self);
VALA_EXTERN ClippedClipboardManager* clipped_clipboard_manager_new (void);
VALA_EXTERN ClippedClipboardManager* clipped_clipboard_manager_construct (GType object_type);
static void clipped_clipboard_manager_real_start (ClippedClipboardManager* self);
static gchar* clipped_clipboard_manager_request_text (ClippedClipboardManager* self);
VALA_EXTERN void clipped_clipboard_manager_paste (ClippedClipboardManager* self);
static void clipped_clipboard_manager_perform_key_event (const gchar* accelerator,
                                                  gboolean press,
                                                  gulong delay);
static void clipped_clipboard_manager_finalize (GObject * obj);
static GType clipped_clipboard_manager_get_type_once (void);

static inline gpointer
clipped_clipboard_manager_get_instance_private (ClippedClipboardManager* self)
{
	return G_STRUCT_MEMBER_P (self, ClippedClipboardManager_private_offset);
}

static void
_clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change (GtkClipboard* _sender,
                                                                          GdkEventOwnerChange* event,
                                                                          gpointer self)
{
	clipped_clipboard_manager_on_clipboard_event ((ClippedClipboardManager*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

ClippedClipboardManager*
clipped_clipboard_manager_construct (GType object_type)
{
	ClippedClipboardManager * self = NULL;
	GtkClipboard* _tmp0_;
	GtkClipboard* _tmp1_;
	self = (ClippedClipboardManager*) g_object_new (object_type, NULL);
	_tmp0_ = gtk_clipboard_get (GDK_SELECTION_CLIPBOARD);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->clipboard);
	self->priv->clipboard = _tmp1_;
	return self;
}

ClippedClipboardManager*
clipped_clipboard_manager_new (void)
{
	return clipped_clipboard_manager_construct (CLIPPED_TYPE_CLIPBOARD_MANAGER);
}

static void
clipped_clipboard_manager_real_start (ClippedClipboardManager* self)
{
	GtkClipboard* _tmp0_;
	_tmp0_ = self->priv->clipboard;
	g_signal_connect_object (_tmp0_, "owner-change", (GCallback) _clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change, self, 0);
}

void
clipped_clipboard_manager_start (ClippedClipboardManager* self)
{
	ClippedClipboardManagerClass* _klass_;
	g_return_if_fail (self != NULL);
	_klass_ = CLIPPED_CLIPBOARD_MANAGER_GET_CLASS (self);
	if (_klass_->start) {
		_klass_->start (self);
	}
}

static void
clipped_clipboard_manager_on_clipboard_event (ClippedClipboardManager* self)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	gboolean text_available = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = clipped_clipboard_manager_request_text (self);
	text = _tmp0_;
	_tmp3_ = text;
	if (_tmp3_ != NULL) {
		const gchar* _tmp4_;
		_tmp4_ = text;
		_tmp2_ = g_strcmp0 (_tmp4_, "") != 0;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		_tmp1_ = TRUE;
	} else {
		GtkClipboard* _tmp5_;
		_tmp5_ = self->priv->clipboard;
		_tmp1_ = gtk_clipboard_wait_is_text_available (_tmp5_);
	}
	text_available = _tmp1_;
	if (text_available) {
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp7_;
		_tmp7_ = text;
		if (_tmp7_ != NULL) {
			const gchar* _tmp8_;
			_tmp8_ = text;
			_tmp6_ = g_strcmp0 (_tmp8_, "") != 0;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			const gchar* _tmp9_;
			_tmp9_ = text;
			g_signal_emit (self, clipped_clipboard_manager_signals[CLIPPED_CLIPBOARD_MANAGER_ON_TEXT_COPIED_SIGNAL], 0, _tmp9_);
		}
	}
	_g_free0 (text);
}

static gchar*
clipped_clipboard_manager_request_text (ClippedClipboardManager* self)
{
	gchar* _result_ = NULL;
	GtkClipboard* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->clipboard;
	_tmp1_ = gtk_clipboard_wait_for_text (_tmp0_);
	_result_ = _tmp1_;
	result = _result_;
	return result;
}

void
clipped_clipboard_manager_paste (ClippedClipboardManager* self)
{
	g_return_if_fail (self != NULL);
	clipped_clipboard_manager_perform_key_event ("<Control>v", TRUE, (gulong) 100);
	clipped_clipboard_manager_perform_key_event ("<Control>v", FALSE, (gulong) 0);
}

static void
clipped_clipboard_manager_perform_key_event (const gchar* accelerator,
                                             gboolean press,
                                             gulong delay)
{
	guint keysym = 0U;
	GdkModifierType modifiers = 0U;
	guint _tmp0_ = 0U;
	GdkModifierType _tmp1_ = 0U;
	Display* display = NULL;
	Display* _tmp2_;
	gint keycode = 0;
	Display* _tmp3_;
	g_return_if_fail (accelerator != NULL);
	gtk_accelerator_parse (accelerator, &_tmp0_, &_tmp1_);
	keysym = _tmp0_;
	modifiers = _tmp1_;
	_tmp2_ = gdk_x11_get_default_xdisplay ();
	display = _tmp2_;
	_tmp3_ = display;
	keycode = (gint) XKeysymToKeycode (_tmp3_, (gulong) keysym);
	if (keycode != 0) {
		Display* _tmp8_;
		if ((modifiers & GDK_CONTROL_MASK) == GDK_CONTROL_MASK) {
			gint modcode = 0;
			Display* _tmp4_;
			Display* _tmp5_;
			_tmp4_ = display;
			modcode = (gint) XKeysymToKeycode (_tmp4_, (gulong) GDK_KEY_Control_L);
			_tmp5_ = display;
			XTestFakeKeyEvent (_tmp5_, (guint) modcode, press, delay);
		}
		if ((modifiers & GDK_SHIFT_MASK) == GDK_SHIFT_MASK) {
			gint modcode = 0;
			Display* _tmp6_;
			Display* _tmp7_;
			_tmp6_ = display;
			modcode = (gint) XKeysymToKeycode (_tmp6_, (gulong) GDK_KEY_Shift_L);
			_tmp7_ = display;
			XTestFakeKeyEvent (_tmp7_, (guint) modcode, press, delay);
		}
		_tmp8_ = display;
		XTestFakeKeyEvent (_tmp8_, (guint) keycode, press, delay);
	}
}

static void
clipped_clipboard_manager_class_init (ClippedClipboardManagerClass * klass,
                                      gpointer klass_data)
{
	clipped_clipboard_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &ClippedClipboardManager_private_offset);
	((ClippedClipboardManagerClass *) klass)->start = (void (*) (ClippedClipboardManager*)) clipped_clipboard_manager_real_start;
	G_OBJECT_CLASS (klass)->finalize = clipped_clipboard_manager_finalize;
	clipped_clipboard_manager_signals[CLIPPED_CLIPBOARD_MANAGER_ON_TEXT_COPIED_SIGNAL] = g_signal_new ("on-text-copied", CLIPPED_TYPE_CLIPBOARD_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}

static void
clipped_clipboard_manager_instance_init (ClippedClipboardManager * self,
                                         gpointer klass)
{
	self->priv = clipped_clipboard_manager_get_instance_private (self);
	self->priv->clipboard = NULL;
}

static void
clipped_clipboard_manager_finalize (GObject * obj)
{
	ClippedClipboardManager * self;
	GtkClipboard* _tmp0_;
	guint _tmp1_;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CLIPPED_TYPE_CLIPBOARD_MANAGER, ClippedClipboardManager);
	_tmp0_ = self->priv->clipboard;
	g_signal_parse_name ("owner-change", gtk_clipboard_get_type (), &_tmp1_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _clipped_clipboard_manager_on_clipboard_event_gtk_clipboard_owner_change, self);
	_g_object_unref0 (self->priv->clipboard);
	G_OBJECT_CLASS (clipped_clipboard_manager_parent_class)->finalize (obj);
}

static GType
clipped_clipboard_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ClippedClipboardManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) clipped_clipboard_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClippedClipboardManager), 0, (GInstanceInitFunc) clipped_clipboard_manager_instance_init, NULL };
	GType clipped_clipboard_manager_type_id;
	clipped_clipboard_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "ClippedClipboardManager", &g_define_type_info, 0);
	ClippedClipboardManager_private_offset = g_type_add_instance_private (clipped_clipboard_manager_type_id, sizeof (ClippedClipboardManagerPrivate));
	return clipped_clipboard_manager_type_id;
}

GType
clipped_clipboard_manager_get_type (void)
{
	static volatile gsize clipped_clipboard_manager_type_id__once = 0;
	if (g_once_init_enter (&clipped_clipboard_manager_type_id__once)) {
		GType clipped_clipboard_manager_type_id;
		clipped_clipboard_manager_type_id = clipped_clipboard_manager_get_type_once ();
		g_once_init_leave (&clipped_clipboard_manager_type_id__once, clipped_clipboard_manager_type_id);
	}
	return clipped_clipboard_manager_type_id__once;
}

